???File Path
==========
***...\ClientApp\srcpp\modelsase\target.model.ts


// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@  SetTarget  @@@@@@@@@@@@@@@@@@
// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
export class MdlSetTarget extends MdlUserAction {

	binSetTargetId: number = 0;
	
	sinTargetType: number = 1;
	binAccountId: number | null = null;
	strAccountCode: string = "";
	strAccountName: string = "";
	binCounterStaffId: number | null = null;
	strCounterStaff: string = "";
	binBranchId: number | null = null;
	strBranch: string = "";
	binAirlineMasterId: number | null = null;
	strAirlineMaster: string = "";
	binHotelMasterId: number | null = null;
	strHotelMaster: string = "";
	
	binFinancialYearId: number = 0;
	strFinancialYear: string = "";
	
	dblRevenueTarget: number = 0.0;
	strRevenueTargetBasedOn: string = "";
	dblYieldTarget: number = 0.0;
	strYieldTargetBasedOn: string = "";
	
	arlConsiderFkBranchIds: number[] = [];
	arlConsiderFkServiceIds: number[] = [];
	arlFkPackageCategoryIds: number[] = [];
	
	sinLessRefund: number = 1;
	
	sinSplitupType: number = 1;
	sinMonthWiseSplitup: number = 1;
	
}

export class MdlReqSetTarget extends MdlRequest {

	mdlSetTarget:MdlSetTarget = new MdlSetTarget();
}

export class MdlResSetTarget extends MdlResponse {

	mdlSetTarget:MdlSetTarget = new MdlSetTarget();
}

export class MdlResSetTargetList extends MdlResponse {

	lstMdlSetTarget: MdlSetTarget[] = [];
}

export class MdlResSetTargetInit extends MdlResponse {
	lstMdlAccountBaseIntId: MdlBaseIntId[] = [];
	lstMdlCounterStaffBaseIntId: MdlBaseIntId[] = [];
	lstMdlBranchBaseIntId: MdlBaseIntId[] = [];
	lstMdlAirlineMasterBaseIntId: MdlBaseIntId[] = [];
	lstMdlHotelMasterBaseIntId: MdlBaseIntId[] = [];
	lstMdlFinancialYearBaseIntId: MdlBaseIntId[] = [];


	lstMdlSetTarget: MdlSetTarget[] = [];
}

